try:
    from plone.i18n.normalizer.interfaces import IUserPreferredURLNormalizer
    from plone.i18n.normalizer.interfaces import IURLNormalizer
    URL_NORMALIZER = True
except ImportError:
    URL_NORMALIZER = False

def generateNewId(self):
    """Suggest an id for this object.
    This id is used when automatically renaming an object after creation.
    """
    title = self.Title()
    # Can't work w/o a title
    if not title:
        return None

    # Don't do anything without the plone.i18n package
    if not URL_NORMALIZER:
        return None

    if not isinstance(title, unicode):
        charset = self.getCharset()
        title = unicode(title, charset)

    request = getattr(self, 'REQUEST', None)
    if request is not None:
        newid = IUserPreferredURLNormalizer(request).normalize(title)
    else:
        newid = queryUtility(IURLNormalizer).normalize(title)
    return newid
