from zope.interface import Interface

class IContextState(Interface):
    """A view that gives access to the state of the current context
    """
    
    def view_url():
        """URL to use for viewing

        Files and Images get downloaded when they are directly
        called, instead of with /view appended.  We want to avoid that.
        """

    def object_url():
        """The URL of the current object
        """
        
    def object_title():
        """The prettified title of the current object
        """
        
    def workflow_state():
        """The workflow state of the current object
        """
    
    def parent():
        """The direct parent of the current object
        """

    def is_folderish(): 
        """True if this is a folderish object, structural or not
        """
    
    def is_structural_folder(): 
        """True if this is a structural folder
        """
